local E, L, V, P, G = unpack(ElvUI);
local mPlugin = "mMediaTag"
local mMT = E:GetModule(mPlugin);
local addon, ns = ...

local function OptionsCurrencys()
	E.Options.args.mMediaTag.args.datatext.args.currencys.args = {
        headerAnima = {
            order = 100,
            type = "header",
            name = format("|CFF3390FF%s|r", L["Anima"]),
        },
        colorAnima = {
            order = 110,
            type = 'select',
            name = L["Anima Color Style"],
            get = function(info) return E.db[mPlugin].mAnima.style end,
            set = function(info, value)
                E.db[mPlugin].mAnima.style = value
            end,
            values = {
                auto  = L["Auto"],
                color = L["Color"],
                white = L["White"],
            },
        },
        iconAnima = {
            order = 120,
            type = 'toggle',
            name = L["Icon"],
            desc = L["Show Icon"],
            get = function(info)
                return E.db[mPlugin].mAnima.icon
            end,
            set = function(info, value)
                E.db[mPlugin].mAnima.icon = value
            end,
        },
        numberAnima = {
            order = 130,
            type = 'toggle',
            name = L["Short Number"],
            desc = L["Short Number"],
            get = function(info)
                return E.db[mPlugin].mAnima.short
            end,
            set = function(info, value)
                E.db[mPlugin].mAnima.short = value
            end,
        },
        showmaxAnima = {
            order = 131,
            type = 'toggle',
            name = L["Show Max Value"],
            desc = L["Show Max Value"],
            get = function(info)
                return E.db[mPlugin].mAnima.showmax
            end,
            set = function(info, value)
                E.db[mPlugin].mAnima.showmax = value
            end,
        },
        nameAnima = {
            order = 140,
            type = 'toggle',
            name = L["Name"],
            desc = L["Shows Name"],
            get = function(info)
                return E.db[mPlugin].mAnima.name
            end,
            set = function(info, value)
                E.db[mPlugin].mAnima.name = value
            end,
        },
        bagAnima = {
            order = 150,
            type = 'toggle',
            name = L["Show Anima in Bags"],
            desc = L["Shows Anima in your Bags"],
            get = function(info)
                return E.db[mPlugin].mAnima.bag
            end,
            set = function(info, value)
                E.db[mPlugin].mAnima.bag = value
            end,
        },
        spacerAnimaStygia = {
            order = 200,
            type = "description",
            name = "\n\n",
        },
        headerStygia = {
            order = 300,
            type = "header",
            name = format("|CFF85C1E9%s|r", L["Stygia"]),
        },
        colorStygia = {
            order = 310,
            type = 'select',
            name = L["Stygia Color Style"],
            get = function(info) return E.db[mPlugin].mStygia.style end,
            set = function(info, value)
                E.db[mPlugin].mStygia.style = value
            end,
            values = {
                auto  = L["Auto"],
                color = L["Color"],
                white = L["White"],
            },
        },
        iconStygia = {
            order = 320,
            type = 'toggle',
            name = L["Icon"],
            desc = L["Show Icon"],
            get = function(info)
                return E.db[mPlugin].mStygia.icon
            end,
            set = function(info, value)
                E.db[mPlugin].mStygia.icon = value
            end,
        },
        numberStygia = {
            order = 320,
            type = 'toggle',
            name = L["Short Number"],
            desc = L["Short Number"],
            get = function(info)
                return E.db[mPlugin].mStygia.short
            end,
            set = function(info, value)
                E.db[mPlugin].mStygia.short = value
            end,
        },
        nameStygia = {
            order = 330,
            type = 'toggle',
            name = L["Name"],
            desc = L["Shows Name"],
            get = function(info)
                return E.db[mPlugin].mStygia.name
            end,
            set = function(info, value)
                E.db[mPlugin].mStygia.name = value
            end,
        },
        spacerStygiaSoulAsh = {
            order = 400,
            type = "description",
            name = "\n\n",
        },
        headerSoulAsh = {
            order = 500,
            type = "header",
            name = format("|CFFF39C12%s|r", L["Soul Ash"]),
        },
        colorSoulAsh = {
            order = 510,
            type = 'select',
            name = L["Soul Ash Color Style"],
            get = function(info) return E.db[mPlugin].mSoulAsh.style end,
            set = function(info, value)
                E.db[mPlugin].mSoulAsh.style = value
            end,
            values = {
                auto  = L["Auto"],
                color = L["Color"],
                white = L["White"],
            },
        },
        iconSoulAsh = {
            order = 520,
            type = 'toggle',
            name = L["Icon"],
            desc = L["Show Icon"],
            get = function(info)
                return E.db[mPlugin].mSoulAsh.icon
            end,
            set = function(info, value)
                E.db[mPlugin].mSoulAsh.icon = value
            end,
        },
        numberSoulAsh = {
            order = 530,
            type = 'toggle',
            name = L["Short Number"],
            desc = L["Short Number"],
            get = function(info)
                return E.db[mPlugin].mSoulAsh.short
            end,
            set = function(info, value)
                E.db[mPlugin].mSoulAsh.short = value
            end,
        },
        showmaxSoulAsh = {
            order = 531,
            type = 'toggle',
            name = L["Show Max Value"],
            desc = L["Show Max Value"],
            get = function(info)
                return E.db[mPlugin].mSoulAsh.showmax
            end,
            set = function(info, value)
                E.db[mPlugin].mSoulAsh.showmax = value
            end,
        },
        nameSoulAsh = {
            order = 540,
            type = 'toggle',
            name = L["Name"],
            desc = L["Shows Name"],
            get = function(info)
                return E.db[mPlugin].mSoulAsh.name
            end,
            set = function(info, value)
                E.db[mPlugin].mSoulAsh.name = value
            end,
        },
        spacerSoulAshInfusedRuby = {
            order = 600,
            type = "description",
            name = "\n\n",
        },
        headerInfusedRub = {
            order = 700,
            type = "header",
            name = format("|CFFEC7063%s|r", L["Infused Ruby"]),
        },
        colorInfusedRub = {
            order = 710,
            type = 'select',
            name = L["Infused Ruby Color Style"],
            get = function(info) return E.db[mPlugin].mInfusedRuby.style end,
            set = function(info, value)
                E.db[mPlugin].mInfusedRuby.style = value
            end,
            values = {
                auto  = L["Auto"],
                color = L["Color"],
                white = L["White"],
            },
        },
        iconInfusedRub = {
            order = 720,
            type = 'toggle',
            name = L["Icon"],
            desc = L["Show Icon"],
            get = function(info)
                return E.db[mPlugin].mInfusedRuby.icon
            end,
            set = function(info, value)
                E.db[mPlugin].mInfusedRuby.icon = value
            end,
        },
        numberInfusedRub = {
            order = 730,
            type = 'toggle',
            name = L["Short Number"],
            desc = L["Short Number"],
            get = function(info)
                return E.db[mPlugin].mInfusedRuby.short
            end,
            set = function(info, value)
                E.db[mPlugin].mInfusedRuby.short = value
            end,
        },
        showmaxInfusedRuby = {
            order = 731,
            type = 'toggle',
            name = L["Show Max Value"],
            desc = L["Show Max Value"],
            get = function(info)
                return E.db[mPlugin].mInfusedRuby.showmax
            end,
            set = function(info, value)
                E.db[mPlugin].mInfusedRuby.showmax = value
            end,
        },
        nameInfusedRub = {
            order = 740,
            type = 'toggle',
            name = L["Name"],
            desc = L["Shows Name"],
            get = function(info)
                return E.db[mPlugin].mInfusedRuby.name
            end,
            set = function(info, value)
                E.db[mPlugin].mInfusedRuby.name = value
            end,
        },
        spacerInfusedRubGratefulOffering = {
            order = 800,
            type = "description",
            name = "\n\n",
        },
        headerGratefulOffering  = {
            order = 900,
            type = "header",
            name = format("|CFFF4D03F%s|r", L["Grateful Offering"]),
        },
        colorGratefulOffering = {
            order = 910,
            type = 'select',
            name = L["Grateful Offering Color Style"],
            get = function(info) return E.db[mPlugin].mGratefulOffering.style end,
            set = function(info, value)
                E.db[mPlugin].mGratefulOffering.style = value
            end,
            values = {
                auto  = L["Auto"],
                color = L["Color"],
                white = L["White"],
            },
        },
        iconGratefulOffering = {
            order = 920,
            type = 'toggle',
            name = L["Icon"],
            desc = L["Show Icon"],
            get = function(info)
                return E.db[mPlugin].mGratefulOffering.icon
            end,
            set = function(info, value)
                E.db[mPlugin].mGratefulOffering.icon = value
            end,
        },
        numberGratefulOffering = {
            order = 930,
            type = 'toggle',
            name = L["Short Number"],
            desc = L["Short Number"],
            get = function(info)
                return E.db[mPlugin].mGratefulOffering.short
            end,
            set = function(info, value)
                E.db[mPlugin].mGratefulOffering.short = value
            end,
        },
        nameGratefulOffering = {
            order = 940,
            type = 'toggle',
            name = L["Name"],
            desc = L["Shows Name"],
            get = function(info)
                return E.db[mPlugin].mGratefulOffering.name
            end,
            set = function(info, value)
                E.db[mPlugin].mGratefulOffering.name = value
            end,
        },
    }
end
table.insert(ns.Config, OptionsCurrencys)